% ex1a.m
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Equazione del calore : diffusione del calore 
%    in un filo metallico di lunghezza unitaria
%	  termicamente isolato con distribuzione 
%    iniziale della temperatura nota . 
%    La sol. u(x,t) rappresenta la distribuzione 
%    della temperatura negli istanti successivi a 
%    quello iniziale.
%    METODO ESPLICITO
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%

% h =stepsize in x
% k =stepsize in t
% M numero di passi temporali in t
% N+1=numero intervalli in x, quindi N numero nodi interni

% caso a
% h=0.1;
% k=0.005125;
% M=200;
% a=1;  % conducibilit termica  a>0, se a grande diffusione rapida,
%       % se a piccolo diffusione lenta
% L=1;

% caso b
h=0.1;
k=0.006;
M=171;
a=1;
L=1;

T=k*M;
N=L/h-1;

w=heat_esp(@f,@g1,@g2,L,T,N,M,a);
%w=heat_impl(@f,@g1,@g2,L,T,N,M,a);
t=0;
x=0:h:(N+1)*h;
for j=1:M
    yexact=exp(-pi^2*t).*sin(pi.*x);
	plot(x,yexact,'r');
    hold on;
    pause
	plot(x,w(j,:),'g');
    t=j*k;
end
legend('sol. esatta','sol. numerica');