function der = Dx(im,opt)
% Effettua una derivazione alle differenze finite centrate lungo le righe
% della matrice
[m n] = size(im);
der = (im([2:m m],:) - im([1 1:m-1],:))./2;
if opt==0
    der(1,:) = zeros(1,n);
    der(m,:) = zeros(1,n);
    der(:,1) = zeros(m,1);
    der(:,n) = zeros(m,1);
end
