% ex1b.m
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Equazione del calore : diffusione del calore 
%    in un filo metallico di lunghezza unitaria
%	  termicamente isolato con distribuzione 
%    iniziale della temperatura nota . 
%    La sol. u(x,t) rappresenta la distribuzione 
%    della temperatura negli istanti successivi a 
%    quello iniziale.
%    METODO IMPLICITO
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%

% h =stepsize in x
% k =stepsize in t
% M numero di passi in t
% N numero di passi in x

h=0.05;
k=0.04;
M=15;
a=1;
L=1;

T=k*M;
N=L/h-1

w=heat_impl(@f_imp,@g1,@g2_imp,L,T,N,M,a);
t=0;
x=0:h:(N+1)*h;
for j=1:M
	plot(x,w(j,:),'r');
    t=j*k;
    hold on;
    pause
end
legend('sol. numerica');