clear all
close all
%%%%%%%%%%%%%%%%%%%%%
% PARAMETRI IMMAGINE %
%%%%%%%%%%%%%%%%%%%%%
%temp = double(imread('fegato','jpg'));
%temp = double(imread('sagittal','jpg'));
temp = double(imread('cerchi200','jpg'));
siz = size(temp);
if length(siz)>2
    A = temp(:,:,1);
else
    A = temp;
end

m = siz(1); n = siz(2);
subplot(221);
imshow(uint8(A));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% AGGIUNTA RUMORE ADDITIVO     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A = addnoise(A,0.3);  
subplot(222);
imshow(uint8(A));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILTRAGGIO CON EQ. del CALORE 2D %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A_lap = A;
iter = 10;
dt = 0.1;
subplot(223);
for l = 1:iter
    A_lap = A_lap + dt.*laplacian(A_lap);
    imshow(uint8(A_lap));
    title(l);
    drawnow
    pause
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILTRAGGIO PER CURVATURA %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A_curv = A;
iter = 200;
dt = 0.5;
subplot(224);
for l = 1:iter
    A_curv = A_curv + dt*k(A_curv).*modgrad(A_curv,1);
    imshow(uint8(A_curv));
    title(l);
    drawnow
end
